import json
import random
import os
import numpy as np
import itertools

from sklearn.feature_extraction.text import TfidfVectorizer
from sklearn.model_selection import train_test_split
from sklearn.model_selection import GridSearchCV
from sklearn.svm import SVR
from sklearn.metrics import mean_absolute_error
from sklearn.preprocessing import normalize, MinMaxScaler

import nltk
from   nltk.corpus import sentiwordnet as swn
from   nltk.corpus import stopwords
from   matplotlib import pyplot as plt


class ImportanceEstimationModel(object):


    def load_data(self, data_path):
        train_data = []
        test_data  = [] 
        ##### YOUR CODE HERE ######

        ###########################
        return train_data, test_data

    def print_train_sample(self, train_data):
        sample = random.choice(train_data)
        premises = sample[0]
        conc   = sample[1]
        print('Conclusion:', conc)
        print('Premises:')
        for idx, premise in enumerate(premises[0:5]):
            print(idx+1, '.', premise)


    def _build_tfidf_model(self, texts):
        ##### YOUR CODE HERE ######

        ###########################
        return tfidf_model

    def _sentiment_features(self, premise):
        premise_words = nltk.word_tokenize(premise)

        num_of_positive_words = 0
        num_of_negative_words = 0
        num_of_neutral_words  = 0
        ##### YOUR CODE HERE ######

        ###########################
        return num_of_positive_words, num_of_negative_words , num_of_neutral_words


    def _num_of_words_feature(self, premise):
        number_of_premise_words = 0
        ##### YOUR CODE HERE ######

        ###########################
        return len(premise_words)

    def _tfidf_features(self, premise):
        avg_tfidf_feature = 0
        max_tfidf_feature = 0
        ##### YOUR CODE HERE ######

        ###########################
        return avg_tfidf_feature, max_tfidf_feature

    def _premise_features(self, premise, premises_text):
        # Number of words
        num_of_words_feature = self._num_of_words_feature(premise)
        
        # Avg. Max. tfidf
        avg_tfidf_feature, max_tfidf_feature = self._tfidf_features(premise)
        
        # Number of postive/negative/neutral words
        num_of_positive_words, num_of_negative_words , num_of_neutral_words  = self._sentiment_features(premise)
        
        return [num_of_words_feature, 
                avg_tfidf_feature, 
                max_tfidf_feature,
                num_of_positive_words, 
                num_of_negative_words, 
                num_of_neutral_words]

    def _instance_features(self, premises):
        premises_text = ' '.join(premises)
        premises_features = np.array([self._premise_features(premise, premises_text) for premise in premises])
        return premises_features

    def instance_scores(self, premises, conclusion):
        premises_scores = []
        ##### YOUR CODE HERE ######

        ###########################
        return premises_scores

    def feature_representation(self, data, mask=None):
        # 1. build a tf-idf model over the training data
        arguments = [' '.join(argument[0]) for argument in data]
        self.tfidf_model = self._build_tfidf_model(arguments)

        # 2. Encode training data into features
        self.train_X = []
        self.train_Y = []

        for argument in data:
            premises     = argument[0]
            conclusion = argument[1]

            premises_vectors = self._instance_features(premises)
            premises_labels  = self.instance_scores(premises, conclusion)

            for premise_vector, premise_label in zip(premises_vectors, premises_labels):
                self.train_X.append(premise_vector)
                self.train_Y.append(premise_label)


        self.train_X = np.array(self.train_X)
        self.train_Y = np.array(self.train_Y)

        return self.train_X, self.train_Y

    def train_grid_search_svr(self, train_X, train_Y):
        svr_params = {'C': [0.001, 0.1, 1.0, 10, 100]}
        best_svr = None
        best_score = None
        ##### YOUR CODE HERE ######

        ###########################
        return best_svr, best_score


    def mrr_evaluation(self, test_data, mask=None):
        mrr_value = 0
        ##### YOUR CODE HERE ######

        ###########################
        return mrr_value